import { AuthConfig } from './interfaces/config.interface';
import { AuthInterceptor } from './auth.interceptor';
import { Auth } from './auth.service';
export declare class AuthModule {
    static forRoot(config?: AuthConfig): {
        ngModule: typeof AuthModule;
        providers: (typeof Auth | {
            provide: typeof AuthConfig;
            useValue: AuthConfig;
            useClass?: undefined;
            multi?: undefined;
            useFactory?: undefined;
            deps?: undefined;
        } | {
            provide: import("@angular/core").InjectionToken<import("@angular/common/http").HttpInterceptor[]>;
            useClass: typeof AuthInterceptor;
            multi: boolean;
            useValue?: undefined;
            useFactory?: undefined;
            deps?: undefined;
        } | {
            useFactory: typeof initializeAuth;
            provide: import("@angular/core").InjectionToken<(() => void)[]>;
            deps: (typeof Auth)[];
            multi: boolean;
            useValue?: undefined;
            useClass?: undefined;
        })[];
    };
}
export declare function initializeAuth(auth: Auth): () => Promise<void>;
