(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs/operators'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation', ['exports', '@angular/core', '@angular/common', 'rxjs/operators', 'rxjs'], factory) :
    (global = global || self, factory((global.bravobit = global.bravobit || {}, global.bravobit['bb-foundation'] = {}), global.ng.core, global.ng.common, global.rxjs.operators, global.rxjs));
}(this, (function (exports, core, common, operators, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/services/platform.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var hasV8BreakIterator = (typeof Intl !== 'undefined' && ((/** @type {?} */ (Intl))).v8BreakIterator);
    var Platform = /** @class */ (function () {
        function Platform(_platformId) {
            this._platformId = _platformId;
        }
        Object.defineProperty(Platform.prototype, "isBrowser", {
            // Browser check.
            get: 
            // Browser check.
            /**
             * @return {?}
             */
            function () {
                return this._platformId
                    ? common.isPlatformBrowser(this._platformId)
                    : typeof document === 'object' && !!document;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isTrident", {
            // Rendering engines.
            get: 
            // Rendering engines.
            /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /(msie|trident)/i.test(navigator.userAgent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isBlink", {
            get: /**
             * @return {?}
             */
            function () {
                return this.isBrowser && (!!(((/** @type {?} */ (window))).chrome || hasV8BreakIterator) &&
                    typeof CSS !== 'undefined' && !this.isEdge && !this.isTrident);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isWebkit", {
            get: /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /AppleWebKit/i.test(navigator.userAgent)
                    && !this.isBlink && !this.isEdge && !this.isTrident;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isChrome", {
            // Browsers.
            get: 
            // Browsers.
            /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /Google Inc./.test(navigator.vendor);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isEdge", {
            get: /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /(edge)/i.test(navigator.userAgent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isFirefox", {
            get: /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /(firefox|minefield)/i.test(navigator.userAgent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isSafari", {
            get: /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /safari/i.test(navigator.userAgent) && this.isWebkit;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isIos", {
            // Platforms.
            get: 
            // Platforms.
            /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /iPad|iPhone|iPod/.test(navigator.userAgent) && !('MSStream' in window);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isAndroid", {
            get: /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /android/i.test(navigator.userAgent) && !this.isTrident;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isDesktop", {
            get: /**
             * @return {?}
             */
            function () {
                return this.isBrowser && !(/(iPhone|iPod|iPad|Android|BlackBerry|IEMobile)/.test(navigator.userAgent));
            },
            enumerable: true,
            configurable: true
        });
        Platform.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        Platform.ctorParameters = function () { return [
            { type: Object, decorators: [{ type: core.Optional }, { type: core.Inject, args: [core.PLATFORM_ID,] }] }
        ]; };
        /** @nocollapse */ Platform.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function Platform_Factory() { return new Platform(core.ɵɵinject(core.PLATFORM_ID, 8)); }, token: Platform, providedIn: "root" });
        return Platform;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        Platform.prototype._platformId;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/services/image-converter.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ImageConverter = /** @class */ (function () {
        function ImageConverter(_platform) {
            this._platform = _platform;
            // Data.
            this._types = ['image/png', 'image/jpeg'];
            this.calculateOffsetAndDimensions = (/**
             * @param {?} image
             * @param {?} canvasWidth
             * @param {?} canvasHeight
             * @return {?}
             */
            function (image, canvasWidth, canvasHeight) {
                /** @type {?} */
                var originalWidth = image.width;
                /** @type {?} */
                var originalHeight = image.height;
                /** @type {?} */
                var widthRatio = canvasWidth / originalWidth;
                /** @type {?} */
                var heightRatio = canvasHeight / originalHeight;
                /** @type {?} */
                var width = 0;
                /** @type {?} */
                var height = 0;
                if (originalWidth > originalHeight) {
                    height = originalHeight * heightRatio;
                    width = (originalWidth / originalHeight) * height;
                }
                else {
                    width = originalWidth * widthRatio;
                    height = (originalHeight / originalWidth) * width;
                }
                /** @type {?} */
                var xOffset = 0;
                /** @type {?} */
                var yOffset = 0;
                if (canvasHeight === height) {
                    xOffset = -((width - canvasWidth) / 2);
                }
                else if (canvasWidth === width) {
                    yOffset = -((height - canvasHeight) / 2);
                }
                return { xOffset: xOffset, yOffset: yOffset, width: width, height: height };
            });
        }
        /**
         * @param {?} contents
         * @param {?=} options
         * @return {?}
         */
        ImageConverter.prototype.toDataUri = /**
         * @param {?} contents
         * @param {?=} options
         * @return {?}
         */
        function (contents, options) {
            if (options === void 0) { options = null; }
            return __awaiter(this, void 0, void 0, function () {
                var image, canvasWidth, canvasHeight, canvas, context, _a, width, height, xOffset, yOffset;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            // Check if the current platform is a browser.
                            if (!this._platform.isBrowser) {
                                return [2 /*return*/, null];
                            }
                            // Get the image.
                            return [4 /*yield*/, this.getImage(contents)];
                        case 1:
                            image = _b.sent();
                            // Get the canvas width and height.
                            canvasWidth = (options && options.width) || image.width;
                            canvasHeight = (options && options.height) || image.height;
                            // Get the canvas and context.
                            canvas = document.createElement('canvas');
                            context = canvas.getContext('2d');
                            canvas.width = canvasWidth;
                            canvas.height = canvasHeight;
                            // Check if dimensions where supplied, else create the image.
                            if (!options) {
                                // Draw the image.
                                context.drawImage(image, 0, 0);
                                // Convert the canvas to a data url.
                                return [2 /*return*/, canvas.toDataURL(this._types[0])];
                            }
                            // Get the dimensions and offsets.
                            _a = this.calculateOffsetAndDimensions(image, canvasWidth, canvasHeight), width = _a.width, height = _a.height, xOffset = _a.xOffset, yOffset = _a.yOffset;
                            // Draw the image.
                            context.drawImage(image, 0, 0, image.width, image.height, xOffset, yOffset, width, height);
                            // Convert the canvas to a data url.
                            return [2 /*return*/, canvas.toDataURL(this._types[0])];
                    }
                });
            });
        };
        /**
         * @param {?} file
         * @param {?=} types
         * @return {?}
         */
        ImageConverter.prototype.fileToImage = /**
         * @param {?} file
         * @param {?=} types
         * @return {?}
         */
        function (file, types) {
            var _this = this;
            if (types === void 0) { types = this._types; }
            return new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                // Check if the file matches an image.
                if (!types.includes(file.type)) {
                    return reject('The selected file does not meet the required format.');
                }
                /** @type {?} */
                var fileReader = new FileReader();
                fileReader.readAsDataURL(file);
                fileReader.onloadend = (/**
                 * @param {?} data
                 * @return {?}
                 */
                function (data) { return __awaiter(_this, void 0, void 0, function () {
                    var dataUri, image;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                // Get the data URI.
                                dataUri = data.target['result'];
                                // Convert the data URI to a image element.
                                return [4 /*yield*/, this.stringToImage(dataUri)];
                            case 1:
                                image = _a.sent();
                                // Resolve the image.
                                return [2 /*return*/, resolve(image)];
                        }
                    });
                }); });
                fileReader.onerror = (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return reject(error); });
            }));
        };
        /**
         * @param {?} src
         * @return {?}
         */
        ImageConverter.prototype.stringToImage = /**
         * @param {?} src
         * @return {?}
         */
        function (src) {
            return new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                /** @type {?} */
                var image = new Image();
                image.src = src;
                image.onload = (/**
                 * @return {?}
                 */
                function () { return resolve(image); });
                image.onerror = (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { return reject(error); });
            }));
        };
        /**
         * @private
         * @param {?} contents
         * @return {?}
         */
        ImageConverter.prototype.getImage = /**
         * @private
         * @param {?} contents
         * @return {?}
         */
        function (contents) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    // If the contents is already an HTML image element just return it.
                    if (contents instanceof HTMLImageElement) {
                        return [2 /*return*/, contents];
                    }
                    // If the contents is a file convert it to an HTML image element.
                    if (contents instanceof File) {
                        return [2 /*return*/, this.fileToImage(contents)];
                    }
                    // If the contents is a string convert it to an HTML image element.
                    if (typeof contents === 'string') {
                        return [2 /*return*/, this.stringToImage(contents)];
                    }
                    return [2 /*return*/];
                });
            });
        };
        ImageConverter.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ImageConverter.ctorParameters = function () { return [
            { type: Platform }
        ]; };
        /** @nocollapse */ ImageConverter.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ImageConverter_Factory() { return new ImageConverter(core.ɵɵinject(Platform)); }, token: ImageConverter, providedIn: "root" });
        return ImageConverter;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ImageConverter.prototype._types;
        /**
         * @type {?}
         * @private
         */
        ImageConverter.prototype.calculateOffsetAndDimensions;
        /**
         * @type {?}
         * @private
         */
        ImageConverter.prototype._platform;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/services/languages.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Languages = /** @class */ (function () {
        function Languages() {
            this.getLanguages = (/**
             * @return {?}
             */
            function () {
                if (typeof navigator !== 'object') {
                    return null;
                }
                /** @type {?} */
                var t = 'anguage';
                /** @type {?} */
                var n = navigator;
                /** @type {?} */
                var f = n['l' + t + 's'];
                /** @type {?} */
                var data = f && f.length ? f : (t = n['l' + t] ||
                    n['browserL' + t] ||
                    n['userL' + t]) ? [t] : t;
                return typeof data === 'string'
                    ? data
                    : data.join(';');
            });
        }
        Object.defineProperty(Languages.prototype, "all", {
            get: /**
             * @return {?}
             */
            function () {
                // Get the languages.
                /** @type {?} */
                var data = this.getLanguages();
                // Parse all languages by using a regex.
                /** @type {?} */
                var strings = (data || '')
                    .match(/((([a-zA-Z]+(-[a-zA-Z0-9]+){0,2})|\*)(;q=[0-1](\.[0-9]+)?)?)*/g);
                // Get the content by parsing the strings.
                /** @type {?} */
                var content = strings.map((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) {
                    if (!item) {
                        return null;
                    }
                    /** @type {?} */
                    var bits = item.split(';');
                    /** @type {?} */
                    var ietf = bits[0].split('-');
                    /** @type {?} */
                    var hasScript = ietf.length === 3;
                    return {
                        code: ietf[0],
                        script: hasScript ? ietf[1] : null,
                        region: hasScript ? ietf[2] : ietf[1],
                        quality: bits[1] ? parseFloat(bits[1].split('=')[1]) : 1.0
                    };
                }));
                // Filter out all the empty items
                // and sort them by the quality.
                return content
                    .filter((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return !!item; }))
                    .sort((/**
                 * @param {?} a
                 * @param {?} b
                 * @return {?}
                 */
                function (a, b) { return b.quality - a.quality; }));
            },
            enumerable: true,
            configurable: true
        });
        Languages.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */ Languages.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function Languages_Factory() { return new Languages(); }, token: Languages, providedIn: "root" });
        return Languages;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        Languages.prototype.getLanguages;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/services/network.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Network = /** @class */ (function () {
        function Network(_platform) {
            this._platform = _platform;
            // Data.
            this._online$ = rxjs.of(true);
            this.getOnlineObservable();
        }
        /**
         * @return {?}
         */
        Network.prototype.online = /**
         * @return {?}
         */
        function () {
            return this._online$;
        };
        /**
         * @private
         * @return {?}
         */
        Network.prototype.getOnlineObservable = /**
         * @private
         * @return {?}
         */
        function () {
            // Validate we are on a browser.
            if (!this._platform.isBrowser) {
                return;
            }
            // Get all the events from the window.
            /** @type {?} */
            var online$ = rxjs.fromEvent(window, 'online').pipe(operators.mapTo(true));
            /** @type {?} */
            var offline$ = rxjs.fromEvent(window, 'offline').pipe(operators.mapTo(false));
            /** @type {?} */
            var now$ = new rxjs.Observable((/**
             * @param {?} subscriber
             * @return {?}
             */
            function (subscriber) {
                subscriber.next(navigator.onLine);
                subscriber.complete();
            }));
            // Merge all event so we get notified when
            // a user is online/offline.
            this._online$ = rxjs.merge(now$, online$, offline$).pipe(operators.map((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return (/** @type {?} */ (value)); })), operators.distinctUntilChanged(), operators.shareReplay(1));
        };
        Network.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        Network.ctorParameters = function () { return [
            { type: Platform }
        ]; };
        /** @nocollapse */ Network.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function Network_Factory() { return new Network(core.ɵɵinject(Platform)); }, token: Network, providedIn: "root" });
        return Network;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        Network.prototype._online$;
        /**
         * @type {?}
         * @private
         */
        Network.prototype._platform;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/services/patch.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Patch = /** @class */ (function () {
        function Patch(_platform) {
            this._platform = _platform;
            this._hasPatchedMobileVerticalHeight = false;
            // Subscriptions.
            this._subscriptions = [];
        }
        /**
         * @return {?}
         */
        Patch.prototype.mobileVerticalHeight = /**
         * @return {?}
         */
        function () {
            // Check if the user has already patched
            // the mobile vertical height.
            if (this._hasPatchedMobileVerticalHeight) {
                return;
            }
            this.periodicallySetDocumentVerticalProperty();
            this._hasPatchedMobileVerticalHeight = true;
        };
        /**
         * @return {?}
         */
        Patch.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._subscriptions.forEach((/**
             * @param {?} subscription
             * @return {?}
             */
            function (subscription) { return subscription.unsubscribe(); }));
        };
        /**
         * @private
         * @return {?}
         */
        Patch.prototype.periodicallySetDocumentVerticalProperty = /**
         * @private
         * @return {?}
         */
        function () {
            // Validate we are using a browser.
            if (!this._platform.isBrowser) {
                return;
            }
            // Listen to a debounced window resize event.
            /** @type {?} */
            var resize$ = rxjs.fromEvent(window, 'resize').pipe(operators.debounceTime(25), operators.startWith(0));
            // Subscribe to the resize observable.
            /** @type {?} */
            var subscription = resize$.subscribe((/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var verticalHeight = window.innerHeight * 0.01;
                /** @type {?} */
                var element = document.documentElement;
                if (!element.style) {
                    return;
                }
                if (!element.style.setProperty) {
                    return;
                }
                document.documentElement.style.setProperty('--vh', verticalHeight + "px");
            }));
            // Save the subscription so we can destroy it later.
            this._subscriptions.push(subscription);
        };
        Patch.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        Patch.ctorParameters = function () { return [
            { type: Platform }
        ]; };
        /** @nocollapse */ Patch.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function Patch_Factory() { return new Patch(core.ɵɵinject(Platform)); }, token: Patch, providedIn: "root" });
        return Patch;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        Patch.prototype._hasPatchedMobileVerticalHeight;
        /**
         * @type {?}
         * @private
         */
        Patch.prototype._subscriptions;
        /**
         * @type {?}
         * @private
         */
        Patch.prototype._platform;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/mixins/constructor.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/coercions/boolean-coercion.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} value
     * @return {?}
     */
    function coerceBooleanProperty(value) {
        return value != null && "" + value !== 'false';
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/mixins/can-disable.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function CanDisable() { }
    if (false) {
        /** @type {?} */
        CanDisable.prototype.disabled;
    }
    /**
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinDisabled(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._disable = false;
                return _this;
            }
            Object.defineProperty(class_1.prototype, "disabled", {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this._disable;
                },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    this._disable = coerceBooleanProperty(value);
                },
                enumerable: true,
                configurable: true
            });
            return class_1;
        }(base));
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/mixins/can-load.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function CanLoad() { }
    if (false) {
        /** @type {?} */
        CanLoad.prototype.loading;
    }
    /**
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinLoad(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._loading = false;
                return _this;
            }
            Object.defineProperty(class_1.prototype, "loading", {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this._loading;
                },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    this._loading = coerceBooleanProperty(value);
                },
                enumerable: true,
                configurable: true
            });
            return class_1;
        }(base));
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/mixins/has-error.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function HasError() { }
    if (false) {
        /** @type {?} */
        HasError.prototype.error;
    }
    /**
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinError(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._error = false;
                return _this;
            }
            Object.defineProperty(class_1.prototype, "error", {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this._error;
                },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    this._error = coerceBooleanProperty(value);
                },
                enumerable: true,
                configurable: true
            });
            return class_1;
        }(base));
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/mixins/can-hide-errors.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function CanHideErrors() { }
    if (false) {
        /** @type {?} */
        CanHideErrors.prototype.hideErrors;
    }
    /**
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinHideErrors(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._hideErrors = false;
                return _this;
            }
            Object.defineProperty(class_1.prototype, "hideErrors", {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this._hideErrors;
                },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    this._hideErrors = coerceBooleanProperty(value);
                },
                enumerable: true,
                configurable: true
            });
            return class_1;
        }(base));
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/mixins/is-focused.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function IsFocused() { }
    if (false) {
        /** @type {?} */
        IsFocused.prototype.focused;
    }
    /**
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinFocused(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._focused = false;
                return _this;
            }
            Object.defineProperty(class_1.prototype, "focused", {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this._focused;
                },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    this._focused = coerceBooleanProperty(value);
                },
                enumerable: true,
                configurable: true
            });
            return class_1;
        }(base));
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/mixins/is-grouped.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function IsGrouped() { }
    if (false) {
        /** @type {?} */
        IsGrouped.prototype.grouped;
    }
    /**
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinGrouped(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._grouped = false;
                return _this;
            }
            Object.defineProperty(class_1.prototype, "grouped", {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this._grouped;
                },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    this._grouped = coerceBooleanProperty(value);
                },
                enumerable: true,
                configurable: true
            });
            return class_1;
        }(base));
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/mixins/is-readonly.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function IsReadonly() { }
    if (false) {
        /** @type {?} */
        IsReadonly.prototype.readonly;
    }
    /**
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinReadonly(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._readonly = false;
                return _this;
            }
            Object.defineProperty(class_1.prototype, "readonly", {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this._readonly;
                },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    this._readonly = coerceBooleanProperty(value);
                },
                enumerable: true,
                configurable: true
            });
            return class_1;
        }(base));
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/mixins/is-required.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function IsRequired() { }
    if (false) {
        /** @type {?} */
        IsRequired.prototype.required;
    }
    /**
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinRequired(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._required = false;
                return _this;
            }
            Object.defineProperty(class_1.prototype, "required", {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this._required;
                },
                set: /**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    this._required = coerceBooleanProperty(value);
                },
                enumerable: true,
                configurable: true
            });
            return class_1;
        }(base));
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/miscellaneous/regex.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var BbRegex = {
        email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
        fullNumber: /^\d*[1-9]\d*$/
    };

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/core/miscellaneous/validator.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbValidator = /** @class */ (function () {
        function BbValidator() {
        }
        /**
         * @param {?} control
         * @return {?}
         */
        BbValidator.email = /**
         * @param {?} control
         * @return {?}
         */
        function (control) {
            if (isEmptyInputValue(control.value)) {
                return null;
            }
            return BbRegex.email.test(control.value) ? null : { email: true };
        };
        /**
         * @param {?} control
         * @return {?}
         */
        BbValidator.fullNumber = /**
         * @param {?} control
         * @return {?}
         */
        function (control) {
            if (isEmptyInputValue(control.value)) {
                return null;
            }
            return BbRegex.fullNumber.test(control.value) ? null : { fullNumber: true };
        };
        /**
         * @param {?} bytes
         * @return {?}
         */
        BbValidator.maxFileSize = /**
         * @param {?} bytes
         * @return {?}
         */
        function (bytes) {
            /** @type {?} */
            var validator = (/**
             * @param {?} control
             * @return {?}
             */
            function (control) {
                /** @type {?} */
                var value = control.value;
                // Validate if the value is a file.
                if (!(value instanceof File)) {
                    return null;
                }
                if (value.size <= bytes) {
                    return null;
                }
                /** @type {?} */
                var maxSize = '0 Bytes';
                if (bytes !== 0) {
                    /** @type {?} */
                    var k = 1024;
                    /** @type {?} */
                    var dm = 2;
                    /** @type {?} */
                    var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
                    /** @type {?} */
                    var index = Math.floor(Math.log(bytes) / Math.log(k));
                    maxSize = parseFloat((bytes / Math.pow(k, index)).toFixed(dm)) + ' ' + sizes[index];
                }
                return { maxFileSize: { maxSize: maxSize } };
            });
            return validator;
        };
        return BbValidator;
    }());
    /**
     * @param {?} value
     * @return {?}
     */
    function isEmptyInputValue(value) {
        // We don't check for string here so it also works with arrays.
        return value == null || value.length === 0;
    }

    exports.BbRegex = BbRegex;
    exports.BbValidator = BbValidator;
    exports.ImageConverter = ImageConverter;
    exports.Languages = Languages;
    exports.Network = Network;
    exports.Patch = Patch;
    exports.Platform = Platform;
    exports.coerceBooleanProperty = coerceBooleanProperty;
    exports.mixinDisabled = mixinDisabled;
    exports.mixinError = mixinError;
    exports.mixinFocused = mixinFocused;
    exports.mixinGrouped = mixinGrouped;
    exports.mixinHideErrors = mixinHideErrors;
    exports.mixinLoad = mixinLoad;
    exports.mixinReadonly = mixinReadonly;
    exports.mixinRequired = mixinRequired;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bravobit-bb-foundation.umd.js.map
